> For the complete documentation index, see [llms.txt](https://docs.zama.org/tfhe-rs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.zama.org/tfhe-rs/tfhe-rs/1.3/get-started/benchmarks/gpu/gpu-programmable-bootstrapping.md).

# Programmable bootstrapping

This document details the GPU performance benchmarks of programmable bootstrapping and keyswitch operations using **TFHE-rs**.

{% hint style="info" %}
All GPU benchmarks were launched on H100 GPUs, and rely on the multithreaded PBS algorithm with a grouping factor set to 4.
{% endhint %}

## P-fail: $$2^{-40}$$

![](https://298266411-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FkMvc1zsbZF9WUe7AqHFM%2Fuploads%2Fgit-blob-5fe4ccac60f79459267ddc32c564d38bb990c062%2Fgpu_pbs_benchmark_tuniform_2m40.svg?alt=media)

## P-fail: $$2^{-64}$$

![](https://298266411-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FkMvc1zsbZF9WUe7AqHFM%2Fuploads%2Fgit-blob-9ee67e3eab197298df93106375d8ddec993585d1%2Fgpu_pbs_benchmark_tuniform_2m64.svg?alt=media)

## P-fail: $$2^{-128}$$

![](https://298266411-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FkMvc1zsbZF9WUe7AqHFM%2Fuploads%2Fgit-blob-53680ba1347a73607625a952d03e58276c7ceb09%2Fgpu_pbs_benchmark_tuniform_2m128.svg?alt=media)

## Reproducing TFHE-rs benchmarks

**TFHE-rs** benchmarks can be easily reproduced from the [source](https://github.com/zama-ai/tfhe-rs).

The following example shows how to reproduce **TFHE-rs** benchmarks:

```shell
#PBS benchmarks:
make bench_pbs_gpu

#KS-PBS benchmarks:
make bench_ks_pbs_gpu
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.zama.org/tfhe-rs/tfhe-rs/1.3/get-started/benchmarks/gpu/gpu-programmable-bootstrapping.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
